*
      SUBROUTINE PAR_GESVD2(NAME, M, N, SV, NPROCS, MMIN, NB,
     $                      NPROW, NPCOL)
*
*        NB,   (NPROW,NPCOL)  
*          
*     PDGESVD2, PDGESVD3, PDGESVD5, PDGESVD6
*
      include 'mpif.h'
*
*  
      INTEGER            M, N, NPROCS, MMIN, NB, NPROW, NPCOL
      CHARACTER*(*)      NAME, SV
*
*   -  
      INTEGER            NPR
      PARAMETER          ( NPR = 6 )
*
*  
      INTEGER            I, IPA, IPS, IPU, IPVT, IPW, IPWOR,
     $                   MP, NQ, MP0, NQ0, MYCOL, MYROW,
     $                   MXLLDA, MXLLDU, MXMP, MXNQ, NB0, NRU, NCVT,
     $                   LWORK, WORKSIZ, SIZE, SIZEB,
     $                   SIZEP, SIZEQ, WANTU, WANTVT, LWMIN, MAXIM,
     $                   WATOBD, WBDTOSVD, WDBDSQR, WPDGEBRD,
     $                   WPDLANGE, WPDORMBRPRT, WPDORMBRQLN
*  
*
*  
      INTEGER            NUMROC
      EXTERNAL           NUMROC
*
*  
*
*  
      INTRINSIC          MAX, MIN, MOD, SQRT, INT, REAL
*
*  
*
*    NB      NPROW, NPCOL
*
      NPROW = INT(SQRT(REAL(NPROCS)))
      NPCOL = NPROCS/NPROW
***      NPROCS1 = NPROW*NPCOL
*
      NB0 = INT(REAL( N/MAX(NPROW,NPCOL) ))
      IF( NB0.LT.4 ) NB = 2
*1      NB0 = INT(REAL( N/NPROW) )
*1      IF( NB0.LT.4 ) NB = NB0
      IF( NB0.GE.4 .AND. NB0.LT.8 ) NB = 4
*
      IF( NB0.GE.8 .AND. NB0.LT.16 ) NB = 8
      IF( NB0.GE.16 .AND. NB0.LT.32 ) NB = 16
      IF( NB0.GE.32 .AND. NB0.LT.64 ) NB = 32
      IF( NB0.GE.64 .AND. NB0.LT.128 ) NB = 64
      IF( NB0.GE.128 .AND. NB0.LT.256 ) NB = 128
      IF( NB0.GE.256 .AND. NB0.LT.512 ) NB = 256
      IF( NB0.GE.512 ) NB = 512
*
*      IA=JA=IU=JU=IVT=JVT= 1
*
      SIZE = MIN( M, N )
      SIZEB = MAX( M, N )
*
      MXMP = NUMROC( M, NB, 0, 0, NPROW )
      MXNQ = NUMROC( N, NB, 0, 0, NPCOL )
*
*    ( MMIN )
*
      MXLLDA = MXMP
      MXLLDU = MXMP
*
      MP = NUMROC( M, NB, MYROW, 0, NPROW )
      NQ = NUMROC( N, NB, MYCOL, 0, NPCOL )
*
         IF( SV .EQ. 'R' ) THEN
            WANTU = 1
         ELSE
            WANTU = 0
         END IF
         IF( SV .EQ. 'L' ) THEN
            WANTVT = 1
         ELSE
            WANTVT = 0
         END IF
*
         IF( SV .EQ. 'A' ) THEN
            WANTVT = 1
            WANTU = 1
         END IF
*
*     A
      IPA = 1
*
*     S (   )
      IPS = IPA + MXLLDA*MXNQ
*     WORK
      IPWOR = IPS + SIZE
*
      MP0 = MXMP
      NQ0 = MXNQ
*
      MAXIM = MAX( MP0, NQ0 )
*
      NRU = NUMROC( SIZE, 1, 0, 0, NPROW*NPCOL )
      NCVT = NUMROC( SIZE, 1, 0, 0, NPROW*NPCOL )
*
      WPDLANGE = MP
      WPDGEBRD = NB*( MP+NQ+1 ) + NQ
      WATOBD = MAX( MAX( WPDLANGE, WPDGEBRD ), MAXIM )
*
    2 IF( NAME .NE. 'PDGESVD2' .AND. NAME .NE. 'PDGESVD5' ) GOTO 5
*
      SIZEP = NUMROC( M, NB, MYPROW, 0, NPROW )
      SIZEQ = NUMROC( N, NB, MYPCOL, 0, NPCOL )
*
      IPU = IPS + SIZE
      IPVT = IPU + MXLLDU*SIZEQ
      IPWOR = IPVT + SIZEP*NQ
*
      WDBDSQR = MAX( 1, 2*SIZE+( 2*SIZE-4 ) )
      WPDORMBRQLN = MAX( ( NB*( NB-1 ) ) / 2, ( SIZEQ+MP )*NB ) +
     $                    NB*NB
      WPDORMBRPRT = MAX( (NB*( NB-1 ) ) / 2, ( SIZEP+NQ )*NB ) +
     $                    NB*NB
      WBDTOSVD = SIZE*( NRU+NCVT ) +
     $                 MAX( WDBDSQR, MAX( WPDORMBRQLN, WPDORMBRPRT ) )
*
      LWMIN = 2 + 6*SIZEB + MAX( WATOBD, WBDTOSVD )
*
*   ,    PDGESVD2(5)
      LWORK = LWMIN
*
      GO TO 3
*
    5 IF( NAME .NE. 'PDGESVD3' .AND. NAME .NE. 'PDGESVD6' ) GOTO 10
*
      IF( WANTVT.EQ.1 ) THEN
         SIZEP = NUMROC( SIZE, NB, MYPROW, 0, NPROW )
      ELSE
         SIZEP = 0
      END IF
      IF( WANTU.EQ.1 ) THEN
         SIZEQ = NUMROC( SIZE, NB, MYPCOL, 0, NPCOL )
      ELSE
         SIZEQ = 0
      END IF
*
      IF( WANTU.EQ.1 .AND. WANTVT.EQ.0 ) THEN
         IPU = IPS + SIZE
         IPWOR = IPU + MXLLDU*SIZEQ
      END IF
      IF( WANTU.EQ.0 .AND. WANTVT.EQ.1 ) THEN
         IPVT = IPS + SIZE
         IPWOR = IPVT + SIZEP*NQ
      END IF
      IF( WANTU.EQ.1 .AND. WANTVT.EQ.1 ) THEN
         IPU = IPS + SIZE
         IPVT = IPU +  MXLLDU*SIZEQ
         IPWOR = IPVT + SIZEP*NQ
      END IF
*
      WDBDSQR = MAX( 1, 2*SIZE+( 2*SIZE-4 )*MAX( WANTU, WANTVT ) )
      WPDORMBRQLN = MAX( ( NB*( NB-1 ) ) / 2, ( SIZEQ+MP )*NB ) +
     $               NB*NB
      WPDORMBRPRT = MAX( ( NB*( NB-1 ) ) / 2, ( SIZEP+NQ )*NB ) +
     $                    NB*NB

      WBDTOSVD = SIZE*( WANTU*NRU+WANTVT*NCVT ) +
     $           MAX( WDBDSQR, MAX( WANTU*WPDORMBRQLN,
     $           WANTVT*WPDORMBRPRT ) )
*
      IF( NAME .NE. 'PDGESVD3' ) GOTO 7
*
      LWMIN = 2 + 6*N + MAX( WATOBD, WBDTOSVD )
      GO TO 8
*
    7 LWMIN = 2 + 6*SIZEB + MAX( WATOBD, WBDTOSVD )
*
*   ,    PDGESVD3(6)
    8 LWORK = LWMIN
*
      GO TO 3
*
*     W
*
    3 IPW = IPWOR + LWORK
*
*     PDLAPRNT  .
*?
      WORKSIZ = MAX( NB, MP )
*
*        
*
      MMIN = IPW + WORKSIZ
*
*      
*
      IF( MYROW.EQ.0 .AND. MYCOL.EQ.0 ) THEN
         WRITE( NPR, FMT = 9992 )NAME
         WRITE( NPR, FMT = 9998 )M, N, NPROCS
         WRITE( NPR, FMT = 9985 )SV
         WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL, MMIN
         WRITE( NPR, FMT = 9993 )NB, NB
         WRITE( NPR,FMT = * )'IPA, IPS,  IPU, IPVT, IPWOR, IPW, MMIN'
         WRITE( NPR, FMT = 9994 )IPA, IPS, IPU, IPVT, IPWOR, IPW, MMIN
*
      END IF
*
 9994 FORMAT( /I2, 6I6 /)
 9985 FORMAT( / '  SV = ', A1 /)
*
   10 CONTINUE
*
 9992 FORMAT( / '     '
     $      '       ', A8/ )
 9998 FORMAT( /'     A ',I2,' *',I2,',',
     $       '    ',I2 / )
 9997 FORMAT( / '    ',I3,' ,',
     $       '    ', I2, ' *', I2, ';' /
     $      '      '/
     $      '    ',
     $      I5,'  '/)
 9993 FORMAT( / '       NB ',
     $       I2,' *',I2 // '     '/)
      RETURN
      END
